---
variables:
  GITLAB_CI_IMAGE_ALPINE: 'alpine:3.16.2'
  GITLAB_CI_STYLE_IMAGE_DEBIAN: "debian:bookworm"
  GITLAB_CI_LLVM_APT_REPOSITORY: "deb http://apt.llvm.org/bookworm/ llvm-toolchain-bookworm-17 main"
  GIT_SUBMODULE_STRATEGY: recursive

stages:
  - static

# 'static' stage
sign_off:
  stage: static
  needs: []
  image: ${GITLAB_CI_IMAGE_ALPINE}
  before_script:
    - apk add --no-cache git
  script: >-
    git log
    --grep "^Signed-off-by: .\+<.\+\(@\| at \).\+\(\.\| dot \).\+>$"
    --invert-grep
    --format="Detected commit '%h' with missing or bad sign-off! Please read 'CONTRIBUTING.md'."
    --exit-code

# 'style' stage
style:
  image: ${GITLAB_CI_STYLE_IMAGE_DEBIAN}
  stage: static
  needs: []
  before_script:
    - apt-get -q update
    - apt-get -qy install gnupg libcurl4 wget
    - echo "$GITLAB_CI_LLVM_APT_REPOSITORY" > /etc/apt/sources.list.d/llvm.list
    - wget -O - https://apt.llvm.org/llvm-snapshot.gpg.key | apt-key add -
    - apt-get -q update
    - apt-get -qy install clang-format-17
  script:
    - find *.proto | xargs clang-format-17 --dry-run --style file --verbose --Werror -i

